using System;
using AspectWeaver.Aspects;

namespace TestAspects
{
	public class DebugPropertyModifyingAspect : Aspect
	{
		[InlineAtStart("//Method[starts-with(@name, 'set_')]"), InlineBeforeReturn("//Method[starts-with(@name, 'set_')]")]
		public void CodeForPrintPropertyValue()
		{
			string contextInfo = GetContextInfo();
			string propertyName = contextInfo.Substring(contextInfo.IndexOf("_") + 1, contextInfo.IndexOf("(") - contextInfo.IndexOf("_") - 1);
			Console.WriteLine(string.Format("{0}={1}", propertyName, this.GetType().GetProperty(propertyName).GetValue(this, null)));
		}
	}
}
